﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Windows;
using System.Threading;

namespace SplashScreenTester {
   public partial class App : Application {
      private Splash _Splash;
      private SplashVM _SplashVM;

      protected override void OnStartup(StartupEventArgs e) {
         base.OnStartup(e);
         StartSplash();
         Thread.Sleep(1300);
         TrySplashMessage("erste Meldung vom LadeProzess");
         Thread.Sleep(1000);
         TrySplashMessage("oh, ich muß noch bisserl überlegen");
         Thread.Sleep(1000);
         var w = new MainWindow();
         w.ContentRendered += (s, cre) => _Splash.Dispatcher.BeginInvoke((Action)CleanUpSplash);
         MainWindow = w;
         w.Show();
      }
      /// <summary> splashMessage will be omitted, if the splash isn't ready yet </summary>
      private void TrySplashMessage(string splashMessage) {
         if(_Splash == null) return;
         if(_SplashVM == null) _SplashVM = (SplashVM)(_Splash.Dispatcher.Invoke((Func<object>)(() => _Splash.DataContext)));
         //implement your own Progress-Reporting, e.g. with Progressbars, slide-shows or whatever
         _SplashVM.Text = splashMessage;
      }
      private void StartSplash() {
         var thr = new Thread(() => {
            _Splash = new Splash();
            _Splash.ShowDialog();
         });
         thr.Priority = ThreadPriority.Highest;
         thr.SetApartmentState(ApartmentState.STA);
         thr.Start();
      }
      private void CleanUpSplash() {
         _Splash.Close();
         //making objects inaccessible from code enables the GarbageCollector to clean them up
         _Splash = null;
         _SplashVM = null;
      }
   }
}
